package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.ui.BurnComposite;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

public class DdrComposite extends BurnComposite {
  protected Button startBurnButton;
  
  private Button browseButton;
  
  private Text fileText;
  
  public DdrComposite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
  }
  
  protected Button createButton(Composite buttonComp, String label) {
    Button button = new Button(buttonComp, 0);
    button.setText(label);
    GridData layoutData = new GridData(576);
    layoutData.minimumWidth = 100;
    button.setLayoutData(layoutData);
    return button;
  }
  
  protected List<Button> createButtons(Composite buttonComp) {
    List<Button> buttons = new ArrayList<>();
    fillButtons(buttonComp, buttons);
    return buttons;
  }
  
  protected void createButtonsControl(Composite parent) {
    Composite buttonComp = new Composite(parent, 0);
    GridData layoutData = new GridData(1800);
    layoutData.horizontalSpan = 3;
    buttonComp.setLayoutData(layoutData);
    List<Button> buttons = createButtons(buttonComp);
    buttonComp.setLayout((Layout)new GridLayout(buttons.size(), true));
  }
  
  protected void createContents(Composite parent) {
    createDirectoryPathEditor(parent);
    createButtonsControl(parent);
  }
  
  protected void createDirectoryPathEditor(Composite parent) {
    Label label = new Label(parent, 0);
    label.setText(Messages.DdrComposite_DirectoryPath);
    this.fileText = new Text(parent, 2048);
    GridData layoutData = new GridData(768);
    layoutData.horizontalSpan = 2;
    this.fileText.setLayoutData(layoutData);
    this.fileText.addListener(24, (Listener)new Object(this));
    this.browseButton = new Button(parent, 0);
    this.browseButton.setText(LABEL_BROWSE);
    this.browseButton.addListener(13, (Listener)new Object(this));
  }
  
  protected void burn() {
    IBurner burner = getBurner();
    if (checkStatus(burner.checkBeforeBurn())) {
      IFastbootProgressMonitor monitor = getProgressMonitor();
      monitor.getEvent().setBurner(getBurner());
      burner.burn(monitor, this.fileText.getText());
    } 
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(4, false);
  }
  
  protected void disableUI() {
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(false); 
    if (this.startBurnButton != null && !this.startBurnButton.isDisposed())
      this.startBurnButton.setEnabled(false); 
  }
  
  protected void enableButtons() {
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(true); 
    if (this.startBurnButton != null && !this.startBurnButton.isDisposed())
      this.startBurnButton.setEnabled(true); 
  }
  
  protected void enableUI() {
    enableButtons();
  }
  
  protected void fillButtons(Composite buttonComp, List<Button> buttons) {
    this.startBurnButton = createButton(buttonComp, Messages.DdrComposite_StartBurn);
    this.startBurnButton.addListener(13, (Listener)new Object(this, buttonComp));
    buttons.add(this.startBurnButton);
  }
}
